package tpdv;

import java.util.*;

/**
 * Classe que representa um catlogo de produtos.
 * Um catlogo contm vrias especificaes de produtos.
 *
 * @author Craig Larman, Jacques Philippe Sauv, jacques@dsc.ufpb.br
 * @version 1.0
 */
class CatalogoDeProdutos implements ICatalogoDeProdutos {
    /**
     * O catlogo de produtos  guardado aqui.
     */
    private Map especsProdutos = new HashMap();

    /**
     * Cria um catlogo de produtos. Esta verso no trata de persistncia.
     * O catlogo  fixo e criado no construtor.
     */
    public CatalogoDeProdutos() {
        int upc1 = 100;
        especsProdutos.put(new Integer(upc1),
                           makeEspecProduto(upc1, (float)1.99, "produto 1"));
        int upc2 = 200;
        especsProdutos.put(new Integer(upc2),
                           makeEspecProduto(upc2, (float)3.49, "produto 2"));
    }

    /**
     * Obtm a especificao de um produto.
     * @param upc o Universal Product Code do produto cuja especificao se deseja.
     * @return A especificao do produto desejado.
     */
    public IEspecProduto getEspecificao(int upc) throws ProdutoInexistenteException {
        IEspecProduto espec = (IEspecProduto)especsProdutos.get(new Integer(upc));
        if(espec == null) {
            throw new ProdutoInexistenteException("Produto inexistente, UPC: " + upc);
        }
        return espec;
    }

    // factory method
    protected IEspecProduto makeEspecProduto(int upc, float preo, String descrio) {
        return new EspecificacaoDeProduto(upc, preo, descrio);
    }
}
