package tpdv;

/**
 * Interface para qualquer tipo de Catlogo de Produtos
 *
 * @author Jacques Philippe Sauv, jacques@dsc.ufpb.br
 * @version 1.0
 */
public interface ICatalogoDeProdutos {
    /**
     * Obtem a especificao de produto, dado o Universal Product Code (UPC)
     * @param upc O Universal Product Code (UPC) do produto desejado
     * @return A especificao de produto, dado o Universal Product Code (UPC)
     */
    public IEspecProduto getEspecificao(int upc) throws ProdutoInexistenteException;
}
