package tpdv;

/**
 * Interface para qualquer tipo de especificao de produto.
 *
 * @author Jacques Philippe Sauv, jacques@dsc.ufpb.br
 * @version 1.0
 */
public interface IEspecProduto {
   /**
    * Obtem o Universal Product Code (UPC) do produto.
    * @return O Universal Product Code (UPC) do produto.
    */
   int getUPC();

   /**
    * Obtem o preo do produto.
    * @return O preo do produto.
    */
   float getPreo();
   
   /**
    * Obtem a descrio do produto.
    * @return A descrio do produto.
    */
   String getDescrio();
}
