package tpdv;

/**
 * Classe que representa uma linha de detalhe de uma venda.
 *
 * @author Craig Larman, Jacques Philippe Sauv, jacques@dsc.ufpb.br
 * @version 1.0
 */
class LinhaDetalheVenda implements ILinhaDetalhe {
    /**
     * A quantidade de itens (do mesmo produto) neste detalhe de venda.
     */
    private int quantidade;
    /**
     * A especificao do produto sendo comprado.
     */
    private IEspecProduto espec;

    /**
     * Cria uma linha de detalhe de uma venda.
     * @param espec A especificao do produto sendo comprado.
     * @param quantidade A quantidade de itens (do mesmo produto) sendo comprados
     */
    public LinhaDetalheVenda(IEspecProduto espec, int quantidade) {
        this.espec = espec;
        this.quantidade = quantidade;
    }

    /**
     * Informa o subtotal da venda correspondendo a esta linha de detalhe.
     * @return O subtotal da venda correspondendo a esta linha de detalhe.
     */
    public float subTotal() {
        return quantidade * espec.getPreo();
    }
}
