package tpdv;

/**
 * Classe que representa um pagamento feito para uma venda.
 *
 * @author Craig Larman, Jacques Philippe Sauv, jacques@dsc.ufpb.br
 * @version 1.0
 */
class Pagamento implements IPagamento {
    /**
     * O valor do pagamento de uma venda.
     */
    private float valor;

    /**
     * Cria um pagamento.
     * @param valorEntregue O valor entregue para pagar a venda.
     */
    public Pagamento(float valorEntregue) {
        this.valor = valorEntregue;
    }

    /**
     * Cria um pagamento.
     * @param valorEntregue O valor entregue para pagar a venda.
     */
    public Pagamento(double valorEntregue) {
        this.valor = (float)valorEntregue;
    }

    /**
     * Retorna o valor entregue para pagar a venda.
     * @return O valor entregue para pagar a venda.
     */
    public float getValor() { return valor; }
}
