package tpdv;

import junit.framework.*;
import tpdv.*;

/**
 * Testes da classe CatalogoDeProdutos.
 *
 */
public class TestaCatalogoDeProdutos extends TestCase {
    protected CatalogoDeProdutos cp1;

    public TestaCatalogoDeProdutos(String name) {
        super(name);
    }
    public static void main(String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    protected void setUp() {
        cp1 = new CatalogoDeProdutos();
    }
    public static Test suite() {
        return new TestSuite(TestaCatalogoDeProdutos.class);
    }
    public void testConstrutor() {
        assert("1", !cp1.equals(null));
    }
    public void testGetEspecificao() {
        try {
            assertEquals("2", 100, cp1.getEspecificao(100).getUPC());
            assertEquals("3", 1.99, cp1.getEspecificao(100).getPreo(), 0.001);
            assertEquals("4", "produto 1", cp1.getEspecificao(100).getDescrio());
            assertEquals("5", 200, cp1.getEspecificao(200).getUPC());
            assertEquals("6", 3.49, cp1.getEspecificao(200).getPreo(), 0.001);
            assertEquals("7", "produto 2", cp1.getEspecificao(200).getDescrio());
        } catch(ProdutoInexistenteException e) {
            fail("getEspecificacao() nao deveria lanar exception");
        }
        try {
            cp1.getEspecificao(1);
            fail("getEspecificacao() deveria lanar exceo");
        } catch(ProdutoInexistenteException e) {
            assertEquals("Produto inexistente, UPC: 1", e.getMessage());
        }
    }
}