package tpdv;

import junit.framework.*;
import tpdv.*;

/**
 * Testes da classe EspecificacaoDeProduto.
 *
 */
public class TestaEspecificacaoDeProduto extends TestCase {
    protected EspecificacaoDeProduto ep1;
    protected EspecificacaoDeProduto ep2;
    protected EspecificacaoDeProduto ep3;

	public TestaEspecificacaoDeProduto(String name) {
		super(name);
	}
	public static void main(String[] args) {
		junit.textui.TestRunner.run(suite());
	}
	protected void setUp() {
        ep1 = new EspecificacaoDeProduto(1, 1.99, "prod1" );
        ep2 = new EspecificacaoDeProduto(1, (float)1.99, "prod1" );
        ep3 = new EspecificacaoDeProduto(2, 2.99, "prod2" );
	}
	public static Test suite() {
		return new TestSuite(TestaEspecificacaoDeProduto.class);
	}
	public void testConstrutor() {
        assert("1", !ep1.equals(null));
        assert("2", !ep2.equals(null));
        assert("3", !ep3.equals(null));
    }
	public void testGetUPC() {
        assertEquals("1", 1, ep1.getUPC());
        assertEquals("2", 1, ep2.getUPC());
        assertEquals("3", 2, ep3.getUPC());
    }
	public void testGetPreo() {
        assertEquals("1", 1.99, ep1.getPreo(), 0.001);
        assertEquals("2", 1.99, ep2.getPreo(), 0.001);
        assertEquals("3", 2.99, ep3.getPreo(), 0.001);
    }
	public void testGetDescrio() {
        assertEquals("1", "prod1", ep1.getDescrio());
        assertEquals("2", "prod1", ep2.getDescrio());
        assertEquals("3", "prod2", ep3.getDescrio());
    }
}