package tpdv;

import junit.framework.*;
import tpdv.*;

/**
 * Testes da classe TPDV.
 *
 */
public class TestaTPDV extends TestCase {
    protected TPDV tpdv1;
	protected ICatalogoDeProdutos cp1;

	public TestaTPDV(String name) {
		super(name);
	}
	public static void main(String[] args) {
		junit.textui.TestRunner.run(suite());
	}
	protected void setUp() {
		cp1 = new CatalogoDeProdutos();
        tpdv1 = new TPDV(cp1);
	}
	public static Test suite() {
		return new TestSuite(TestaTPDV.class);
	}
	public void testConstrutor() {
        assert("1", !tpdv1.equals(null));
	    assert("2", tpdv1.isNovaVenda());
    }
	public void testFazerVenda() {
        try {
  		    tpdv1.entraItem(100, 1);
        } catch(ProdutoInexistenteException e) {
            fail("entraItem(100) nao deveria gerar exception");
        }
		assert("1", !tpdv1.isNovaVenda());
		assertEquals("2", 1.99, tpdv1.getVenda().total(), 0.001);
        try {
  	    	tpdv1.entraItem(200, 3);
        } catch(ProdutoInexistenteException e) {
          fail("entraItem(200) nao deveria gerar exception");
        }
		assert("3", !tpdv1.isNovaVenda());
		assertEquals("4", 12.46, tpdv1.getVenda().total(), 0.001);
        try {
    		tpdv1.faaPagamento((float)5.0);
            fail("facaPagamento(5.0) deveria gerar exception");
        } catch(PagamentoInsuficienteException e) {}
        try {
    		tpdv1.faaPagamento((float)20.0);
        } catch(PagamentoInsuficienteException e) {
          fail("facaPagamento(20.0)nao deveria gerar exception");
        }
		assertEquals("5", 7.54, tpdv1.getVenda().getTroco(), 0.001);
        try {
    		tpdv1.fimDeVenda();
        } catch(NaoHaVendaException e) {
          fail("fimDeVenda() nao deveria gerar exception");
        }
		assert("6", tpdv1.isNovaVenda());
    }
}