package tpdvui;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import tpdv.*;

public class TpdvFrame extends JFrame {
  Loja loja = new Loja();
  ITPDV tpdv = loja.getTPDV();
  JPanel jPanel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel2 = new JPanel();
  JButton fimVenda = new JButton();
  JButton entraItem = new JButton();
  JButton faaPagamento = new JButton();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  GridLayout gridLayout1 = new GridLayout();
  JLabel jLabel1 = new JLabel();
  JTextField upc = new JTextField();
  JLabel jLabel2 = new JLabel();
  JTextField total = new JTextField();
  JLabel jLabel3 = new JLabel();
  JTextField valorEntregue = new JTextField();
  GridLayout gridLayout2 = new GridLayout();
  JLabel jLabel4 = new JLabel();
  JTextField quantidade = new JTextField();
  JLabel jLabel5 = new JLabel();
  JLabel jLabel6 = new JLabel();
  JLabel jLabel7 = new JLabel();
  JTextField troco = new JTextField();

  //Construct the frame
  public TpdvFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try  {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {
    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(400, 300));
    this.setTitle("Loja da Esquina, Ltda.");
    jPanel2.setPreferredSize(new Dimension(50, 50));
    jPanel1.setPreferredSize(new Dimension(200, 200));
    fimVenda.setText("Fim Venda");
    fimVenda.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        fimVenda_actionPerformed(e);
      }
    });
    entraItem.setText("Entra Item");
    entraItem.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        entraItem_actionPerformed(e);
      }
    });
    faaPagamento.setText("Faa Pagamento");
    faaPagamento.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        faaPagamento_actionPerformed(e);
      }
    });
    jPanel3.setMinimumSize(new Dimension(100, 100));
    jPanel3.setPreferredSize(new Dimension(170, 200));
    jPanel3.setLayout(gridLayout2);
    jPanel4.setAlignmentX((float) 0.0);
    jPanel4.setAlignmentY((float) 0.0);
    jPanel4.setPreferredSize(new Dimension(170, 200));
    jPanel4.setLayout(gridLayout1);
    gridLayout1.setColumns(2);
    gridLayout1.setHgap(10);
    gridLayout1.setRows(3);
    gridLayout1.setVgap(50);
    jLabel1.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel1.setText("UPC");
    upc.setMinimumSize(new Dimension(4, 10));
    upc.setPreferredSize(new Dimension(63, 10));
    upc.addActionListener(new java.awt.event.ActionListener() {

      public void actionPerformed(ActionEvent e) {
        upc_actionPerformed(e);
      }
    });
    jLabel2.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel2.setText("Total");
    total.setMinimumSize(new Dimension(4, 10));
    total.setPreferredSize(new Dimension(63, 10));
    total.setEditable(false);
    jLabel3.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel3.setText("Valor Entegue");
    gridLayout2.setColumns(2);
    gridLayout2.setHgap(10);
    gridLayout2.setRows(3);
    gridLayout2.setVgap(50);
    jLabel4.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel4.setText("Quantidade");
    jLabel7.setHorizontalAlignment(SwingConstants.RIGHT);
    jLabel7.setText("Troco");
    troco.setEditable(false);
    this.getContentPane().add(jPanel2, BorderLayout.SOUTH);
    jPanel2.add(entraItem, null);
    jPanel2.add(fimVenda, null);
    jPanel2.add(faaPagamento, null);
    this.getContentPane().add(jPanel1, BorderLayout.NORTH);
    jPanel1.add(jPanel4, null);
    jPanel4.add(jLabel1, null);
    jPanel4.add(upc, null);
    jPanel4.add(jLabel2, null);
    jPanel4.add(total, null);
    jPanel4.add(jLabel3, null);
    jPanel4.add(valorEntregue, null);
    jPanel1.add(jPanel3, null);
    jPanel3.add(jLabel4, null);
    jPanel3.add(quantidade, null);
    jPanel3.add(jLabel5, null);
    jPanel3.add(jLabel6, null);
    jPanel3.add(jLabel7, null);
    jPanel3.add(troco, null);
  }

  //Overridden so we can exit on System Close
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if(e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }

  void faaPagamento_actionPerformed(ActionEvent e) {
    if(valorEntregue.getText().equals("")) {
        JOptionPane.showMessageDialog(this, "Qual  o valor entregue?");
        return;
    }
    try {
        tpdv.faaPagamento((float)Double.parseDouble(valorEntregue.getText()));
    } catch(PagamentoInsuficienteException ex) {
        JOptionPane.showMessageDialog(this, ex.getMessage());
        return;
    }
    troco.setText(String.valueOf(tpdv.getVenda().getTroco()));
  }

  void entraItem_actionPerformed(ActionEvent e) {
    if(upc.getText().equals("")) {
        JOptionPane.showMessageDialog(this, "UPC deve ser informado");
        return;
    }
    if(quantidade.getText().equals("")) {
        JOptionPane.showMessageDialog(this, "Quantidade deve ser informada");
        return;
    }
    int upcInt = 0;
    int quant = 0;
    try {
        upcInt = Integer.parseInt(upc.getText());
    } catch(NumberFormatException ex) {
        JOptionPane.showMessageDialog(this, "Produto " + upc.getText() + " inexistente");
        return;
    }
    try {
        quant = Integer.parseInt(quantidade.getText());
    } catch(NumberFormatException ex) {
        JOptionPane.showMessageDialog(this, "Quantidade deve ser numrica");
        return;
    }
    try {
        tpdv.entraItem(upcInt, quant);
    } catch(ProdutoInexistenteException ex) {
        JOptionPane.showMessageDialog(this, ex.getMessage());
        return;
    }
    upc.setText("");
    quantidade.setText("");
    total.setText("");
    valorEntregue.setText("");
    troco.setText("");
  }

  void upc_actionPerformed(ActionEvent e) {

  }

  void fimVenda_actionPerformed(ActionEvent e) {
    try {
        tpdv.fimDeVenda();
    } catch(NaoHaVendaException ex) {
        JOptionPane.showMessageDialog(this, ex.getMessage());
        return;
    }
    total.setText(String.valueOf(tpdv.getVenda().total()));
  }
}
